DAT programName byte "Led3ByteColor130608hP", 0 ' This will let me know what program is loaded in the Prop.
CON
{{
  ******* Public Notes *******

  Written By: Duane Degn
  Initial Release: June 2013
  MIT License (Use anyway you want but give me credit.)
  
  This is a program to light RGB LEDs using '595 shift registers.   
  Make sure and use current limiting resistors on your LEDs.
  

}}
{
  ******* Private Notes *******
  
  07e Flip anodes in LED driver.
  07f Program kind of works. Rainbow text has problems.
  08a Fixed column buffer problem.
  08b Comment out a bunch of debug statements.
  08c Switch to single menu. No submenus for now.
  08d Add scroll speed control. Added pattern back as an option.
  08f Add a couple of more features.
  08g Clean up child object a bit. Still works.
  08h Save as Led3ByteColor130608hP remove most of the commented out code.
  
} 
CON


  _CLKMODE = XTAL1 + PLL16X                             ' use crystal x 16
  _XINFREQ = 5_000_000                                  ' 5 MHz cyrstal (sys clock = 80 MHz)

  
  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000

  
  
  ' Pin Assignments
  ' Shift Registers
  SHIFT_DATA = 16
  SHIFT_CLOCK = 27
  SHIFT_LATCH = 15        

  ' Anode Control
  FIRST_ANODE_PIN = 0           ' The seven pins after FIRST_ANODE_PIN will also be used
                                ' for anode control. 

  DATA_RESOLUTION = 256
  STACK_SIZE = 100
  BAUD = 115_200
  PSEUDO_MULTIPLIER = 1000
 

  DEFAULT_SHORT_PAUSE = 100
  BUFFER_DUMP_COLUMNS = 32
  TITLE_X = 3                   ' Location for title
  TITLE_Y = 1
 
  MODE_DISPLAY_X = TITLE_X '+ 11               
  MODE_DISPLAY_Y = TITLE_Y + 4
  ACTIVE_COLOR_DISPLAY_X = TITLE_X '+ 15               
  ACTIVE_COLOR_DISPLAY_Y = MODE_DISPLAY_Y + 1
  ACTIVE_LEDS_DISPLAY_X = TITLE_X '+ 14               
  ACTIVE_LEDS_DISPLAY_Y = ACTIVE_COLOR_DISPLAY_Y + 1
  ACTIVE_BRIGHTNESS_DISPLAY_X = TITLE_X '+ 20              
  ACTIVE_BRIGHTNESS_DISPLAY_Y = ACTIVE_LEDS_DISPLAY_Y + 1
  SPEED_DISPLAY_X = ACTIVE_BRIGHTNESS_DISPLAY_X
  SPEED_DISPLAY_Y = ACTIVE_BRIGHTNESS_DISPLAY_Y + 1
  MENU_DISPLAY_X = TITLE_X                
  MENU_DISPLAY_Y = SPEED_DISPLAY_Y + 2
  BUFFER_DUMP_Y = MENU_DISPLAY_Y + 18

  #0, FORWARD, BACKWARD

  COUNTER_CLOCKWISE = FORWARD
  CLOCKWISE = BACKWARD
  
  ' color enumeration tri color LEDs
  #0, BLACK, RED, ORANGE, YELLOW, GREEN, BLUE, VIOLET, WHITE, CYAN, INDIGO, CUSTOM_COLOR, RAINBOW

  FIRST_RAINBOW_COLOR = RED
  LAST_RAINBOW_COLOR = VIOLET

  #0, RED_PORTION, GREEN_PORTION, BLUE_PORTION


  #0, OFF_MODE, LARSON_MODE, SOLID_MODE, DRAGON_MODE, TAIL_MODE, ROTATE_MODE, {
    } PULSE_MODE, BOW_MODE, PATTERN_MODE, CYCLE_MODE, TEXT_MODE, UPDATE_TEXT_MODE, {
    } {RAINBOW_TEXT_MODE, }WHITE_MODE, RAINBOW_ANGLED_MODE, CYCLE_TEXT_MODE

  ' menuMode enumeration
  #0, MAIN_MENU, COLOR_MENU, NUMBER_MENU, TEXT_MENU, MESSAGE_MENU{, 
     CHOOSE_CONFIRM_MESSAGE, CHOOSE_TEXT_COLOR}

  ' ledType enumeration (only RGB LEDs are currently supported in this program)
  #1, SINGLE_COLOR, BI_COLOR, TRI_COLOR
    ' I plan to add support for monochromatic LEDs but I don't presently
    ' have plans to support BI_COLOR LEDs.
  
CON

  EEPROM_FONT_ADDRESS = $8000  '' EEPROM not currently used.

  ARRAYS_HIGH = 1            '' Do not change these constants.
  RESOLUTION_BITS = 3 ' 5
  ZONES_WIDE = 2
  ZONE_WIDTH = 1
  ZONES = ZONES_WIDE * ARRAYS_HIGH 
  ARRAYS_WIDE = ZONES_WIDE * ZONE_WIDTH

  FONT_HEIGHT = 8
  FONT_WIDTH = 8
  ARRAY_WIDTH_PIXELS = 8
  ARRAY_HEIGHT = 8
  DISPLAY_WIDTH_PIXELS = ARRAYS_WIDE * ARRAY_WIDTH_PIXELS ' 16
  DISPLAY_BYTES_WIDTH = DISPLAY_WIDTH_PIXELS * TRI_COLOR
  DISPLAY_HEIGHT = ARRAYS_HIGH * ARRAY_HEIGHT
  DISPLAY_BYTES = DISPLAY_BYTES_WIDTH * DISPLAY_HEIGHT
  DISPLAY_PIXELS = DISPLAY_WIDTH_PIXELS * DISPLAY_HEIGHT
  FONT_EEPROM_BYTE_HEIGHT = FONT_HEIGHT
  FONT_EEPROM_BYTE_WIDTH = FONT_WIDTH * TRI_COLOR
  DEFAULT_INIT_SKIP = 2
  DEFAULT_END_SKIP = 3
  DEFAULT_SPACE_BETWEEN_LETTERS = 3 '' user changable 
  DEFAULT_N_SPACING = 6 ' space between words   '' user changable 
  DEFAULT_BRIGHTNESS = 100          '' user changable but don't go higher
  MAX_BRIGHTNESS = $FF              '' user changable 
  MIN_BRIGHTNESS = 8                '' user changable any lower wont show up
  LARGE_BRIGHTNESS_CHANGE = 10      '' user changable 
  SMALL_BRIGHTNESS_CHANGE = 1       '' user changable 
  FONT_BYTES_PER_CHARACTER = FONT_EEPROM_BYTE_HEIGHT * FONT_EEPROM_BYTE_WIDTH 
  FONT_BYTES_IN_EEPROM = FONT_BYTES_PER_CHARACTER + 1 ' one byte to hold width of character

  LOWEST_ASCII_USED = 32
  HIGHEST_ASCII_USED = 126   


  DEFAULT_H_SCROLL_DELAY = 100      '' user changable
  DEFAULT_SCROLL_SPEED = 80         '' user changable 
  MIN_SCROLL_SPEED = 0              '' user changable 
  MAX_SCROLL_SPEED = 100            '' user changable but don't go higher
  LARGE_SPEED_CHANGE = 10           '' user changable 
  SMALL_SPEED_CHANGE = 1            '' user changable 
  LARGEST_TEXT_MESSAGE = 140 'Pst#MAXSTR_LENGTH + 1 '160
  MAX_NUMBER_OF_MESSAGES = 256
  DEFAULT_COLOR_TRANSITIONS = 8
  
CON  '' this section is user changable

  RED_R = $FF
  RED_G = 0
  RED_B = 0
  ORANGE_R = $FF
  ORANGE_G = $2F
  ORANGE_B = 0
  YELLOW_R = $FF
  YELLOW_G = $6F
  YELLOW_B = 0
  GREEN_R = 0
  GREEN_G = $FF
  GREEN_B = 0
  BLUE_R = 0
  BLUE_G = 0
  BLUE_B = $FF
  CYAN_R = 0
  CYAN_G = $FF
  CYAN_B = $FF
  INDIGO_R = $3F
  INDIGO_G = 0
  INDIGO_B = $FF
  VIOLET_R = $8F
  VIOLET_G = 0
  VIOLET_B = $FF
  WHITE_R = $FF
  WHITE_G = $CF
  WHITE_B = $3F
CON

  PIN_TX        =   23             ' used to communicate with SimplyTronics array
  PIN_RX        =   22 

CON

  #0, FREE_DESIGN, SIMPLYTRONICS_0508', SIMPLYTRONICS_0816

  FONTS_AVAILABLE = SIMPLYTRONICS_0508 + 1 'SIMPLYTRONICS_0816 + 1

  FREE_DESIGN_WIDTH = 8
  SIMPLYTRONICS_0508_WIDTH = 8 '5
  'SIMPLYTRONICS_0816_WIDTH = 8
  FREE_DESIGN_HEIGHT = 8
  SIMPLYTRONICS_0508_HEIGHT = 8
  'SIMPLYTRONICS_0816_HEIGHT = 16
  WIDEST_POSSIBLE_FONT = 16  ' current widest is 8 but I plan to add wider fonts

  '' Control Characters
  SET_DELAY = $04
  SET_FONT = $05                ' followed by single byte
  SET_BRIGHTNESS_ST = $07       ' followed by single byte
  SET_BRIGHTNESS = $07          ' followed by single byte
  SET_FOREGROUND_COLOR = $08    ' followed by single byte
  SET_BACKGROUND_COLOR = $09    ' followed by single byte
  SET_FOREGROUND_RGB = $0B      ' followed by three bytes
  SET_BACKGROUND_RGB = $0C      ' followed by three bytes
  SD = SET_DELAY
  SF = SET_FONT
  SB = SET_BRIGHTNESS
  SBST = SET_BRIGHTNESS_ST                
  SFC = SET_FOREGROUND_COLOR 
  SBC = SET_BACKGROUND_COLOR 
  SFRGB = SET_FOREGROUND_RGB 
  SBRGB = SET_BACKGROUND_RGB
     
VAR


  long ledStack[STACK_SIZE] 
  long globalWait
  long globalLastTime, oneSecond, millisecond
  long debugLock
  long timesToFlash, flashDurationMs
  long ledCog, brightness, brightnessSt
  long activeLeds, activeLedsUpperLimit, activeLedsLowerLimit
  long shortPause, patternSize, horizontalScrollDelay
  long eepromFontColor
  long nextFreeEepromLoc, colorTransition[TRI_COLOR]
  long globalColor[TRI_COLOR]
  long fontPtr[FONTS_AVAILABLE], stScrollIndex, pStScrollIndex
  long pactiveColorIndexL, messageLocation[MAX_NUMBER_OF_MESSAGES], messagesSavedCount 
  long incrementTimer, colorTransitions
  long pseudoColorIncrement[TRI_COLOR]
  long nextRainbowIndex, scrollSpeed
  long menuMode, ledType, activeColorIndex
   
  byte dayOfWeek, interuptFlag, globalChangeFlag
  byte ledMode, previousLedMode
  byte tempBuffer[DISPLAY_BYTES]
  byte modifiableColorFlag, modifiableNumberFlag, modifiableBrightnessFlag
  byte displayBuffer[DISPLAY_BYTES * 2]
  byte rainbowIndex, rainbowTransitionIndex
  byte fontWidth[FONTS_AVAILABLE], fontHeight[FONTS_AVAILABLE]
  byte activeFont, activeCharacter, previousCharacter, pactiveColorIndex
  byte pActiveFont  
  byte messageSize[MAX_NUMBER_OF_MESSAGES]
  byte bufferSavedFlag, overTimeFlag
  byte columnColors[DISPLAY_BYTES_WIDTH] 
  byte nextColors[TRI_COLOR], characterColors[TRI_COLOR]
  
OBJ
{ RGB LED Matirx Library}                                            
  Rgb    : "RGB_LED_Matrix_Driver_Simple3.spin"    

OBJ

  Pst : "Parallax Serial Terminal"                      ' uses a cog
  Led : "Led3BytePasm130109a0608b"                       ' uses a cog
  Eeprom: "Propeller EepromDWD"
  
PUB SetUp | localIndex, localCharacter, count, colorIndex1, colorIndex2, colorIndex3
' uses a cog 3 left
      'Initialize the RC input object
  
  Pst.Start(BAUD)
  oneSecond := clkfreq
  millisecond := clkfreq / 1000
  fontWidth[FREE_DESIGN] := FREE_DESIGN_WIDTH
  fontHeight[FREE_DESIGN] := FREE_DESIGN_HEIGHT
  fontWidth[SIMPLYTRONICS_0508] := SIMPLYTRONICS_0508_WIDTH
  fontHeight[SIMPLYTRONICS_0508] := SIMPLYTRONICS_0508_HEIGHT
  'fontWidth[SIMPLYTRONICS_0816] := SIMPLYTRONICS_0816_WIDTH
  'fontHeight[SIMPLYTRONICS_0816] := SIMPLYTRONICS_0816_HEIGHT
  fontPtr[FREE_DESIGN] := @freeDesign032 
  fontPtr[SIMPLYTRONICS_0508] := @ASCII_0508_032
  'fontPtr[SIMPLYTRONICS_0816] := @ASCII_0816_032
  activeFont := FREE_DESIGN 'SIMPLYTRONICS_0508
  pActiveFont := FREE_DESIGN
  colorTransitions := DEFAULT_COLOR_TRANSITIONS
  rainbowIndex := FIRST_RAINBOW_COLOR
  nextRainbowIndex := rainbowIndex + 1
  GetColors(rainbowIndex, @characterColors)
  GetColors(nextRainbowIndex, @nextColors)
  FindIncrementalColors(@characterColors, @nextColors, @pseudoColorIncrement, colorTransitions + 1)
    
  debugLock := locknew                                  ' used for debug output, not input
  timesToFlash := 8
  flashDurationMs := 250
  brightness := MAX_BRIGHTNESS
  brightnessSt := MAX_BRIGHTNESS
  ledType := TRI_COLOR
  modifiableColorFlag := 1
  modifiableNumberFlag := 1
  activeLedsUpperLimit := DISPLAY_PIXELS 
  activeLedsLowerLimit := 0
  modifiableBrightnessFlag := 1
  ledMode := TEXT_MODE 'OFF_MODE 'SOLID_MODE
  menuMode := MAIN_MENU
  
  activeColorIndex := RAINBOW 'RED
  activeLeds := 5 'DISPLAY_PIXELS
  shortPause := DEFAULT_SHORT_PAUSE
  'horizontalScrollDelay := DEFAULT_H_SCROLL_DELAY * MS_001
  scrollSpeed := DEFAULT_SCROLL_SPEED
  horizontalScrollDelay := SetSpeed(scrollSpeed)
  waitcnt(clkfreq + cnt)
    
  localCharacter := cognew(LightLeds, @ledStack)        ' uses a cog 1 left
  eepromFontColor := WHITE                                                 
 
  bufferSavedFlag := 1    
  repeat until not lockset(debugLock)
  Pst.Clear
  Pst.Position(TITLE_X, TITLE_Y)
  Pst.str(string("8 x 8 RGB LED Array Demo"))
  Pst.Position(TITLE_X, TITLE_Y + 2)
  Pst.str(string("program name of top object = "))
  Pst.str(@programName)
  Pst.Position(TITLE_X, TITLE_Y + 3)
  lockclr(debugLock)
 
  waitcnt(clkfreq / 4 + cnt)
 
  MainLoop

PUB MainLoop | colorIndex, brightnessIndex, direction 
''  This method resides in cog 0.  It checks for new information
''  received by other cogs and takes action based on such information.

  timesToFlash := 2
  flashDurationMs := 250
  patternSize := @patternD01 - @patternD02
  direction := 1
  repeat
    MainMenu

PUB MainMenu | localCharacter


  DisplayInfo
  repeat until not lockset(debugLock)
  Pst.str(@mainMenuText)
  
  lockclr(debugLock)
  
  repeat  
    localCharacter := Pst.RxCount
    if localCharacter
      localCharacter := Pst.CharIn
        
      case localCharacter
        "S", "s": 
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          modifiableBrightnessFlag := 0
          ledMode := OFF_MODE      
        "P", "p":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := PULSE_MODE            
        "A", "a":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := PATTERN_MODE
        "L", "l":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := CYCLE_MODE
        "T", "t":
          modifiableColorFlag := 1
          modifiableNumberFlag := 0
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          menuMode := MAIN_MENU  'TEXT_MENU
          ledMode := TEXT_MODE
          activeColorIndex #>= RED
          activeColorIndex <#= RAINBOW          
        "X", "x":
          modifiableColorFlag := 1
          modifiableNumberFlag := 0
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          menuMode := MAIN_MENU
          activeColorIndex := RAINBOW 
          ledMode := TEXT_MODE   
        "+":
          if modifiableBrightnessFlag
            result := brightness + SMALL_BRIGHTNESS_CHANGE
            brightness :=  result <# MAX_BRIGHTNESS
            DisplayBrightness
        "-":
          if modifiableBrightnessFlag
            result := brightness - SMALL_BRIGHTNESS_CHANGE
            brightness :=  result #> MIN_BRIGHTNESS
            DisplayBrightness
        "*":
          if modifiableBrightnessFlag
            result := brightness + LARGE_BRIGHTNESS_CHANGE
            brightness :=  result <# MAX_BRIGHTNESS
            DisplayBrightness
        "/":
          if modifiableBrightnessFlag
            result := brightness - LARGE_BRIGHTNESS_CHANGE
            brightness :=  result #> MIN_BRIGHTNESS
            DisplayBrightness
        "4":
          result := scrollSpeed - SMALL_SPEED_CHANGE
          scrollSpeed :=  result #> MIN_SCROLL_SPEED
          horizontalScrollDelay := SetSpeed(scrollSpeed)
          DisplaySpeed
        "6":
          result := scrollSpeed + SMALL_SPEED_CHANGE
          scrollSpeed :=  result <# MAX_SCROLL_SPEED
          horizontalScrollDelay := SetSpeed(scrollSpeed)
          DisplaySpeed
        "2":
          result := scrollSpeed - LARGE_SPEED_CHANGE
          scrollSpeed :=  result #> MIN_SCROLL_SPEED
          horizontalScrollDelay := SetSpeed(scrollSpeed)
          DisplaySpeed
        "8":
          result := scrollSpeed + LARGE_SPEED_CHANGE
          scrollSpeed :=  result <# MAX_SCROLL_SPEED
          horizontalScrollDelay := SetSpeed(scrollSpeed)
          DisplaySpeed   
        "0":
          activeFont := FREE_DESIGN
        "1":
          activeFont := SIMPLYTRONICS_0508
        "R", "r":
          activeColorIndex := RED
          menuMode := MAIN_MENU
        "O", "o":
          activeColorIndex := ORANGE
          menuMode := MAIN_MENU
        "Y", "y":
          activeColorIndex := YELLOW
          menuMode := MAIN_MENU
        "G", "g":
          activeColorIndex := GREEN
          menuMode := MAIN_MENU
        "B", "b":
          activeColorIndex := BLUE
          menuMode := MAIN_MENU
        "I", "i":
          activeColorIndex := INDIGO
          menuMode := MAIN_MENU
        "V", "v":
          activeColorIndex := VIOLET
          menuMode := MAIN_MENU
        "W", "w":
          activeColorIndex := WHITE
          menuMode := MAIN_MENU        
        other:
          DisplayNotValid(localCharacter)
          quit

      
  while menuMode == MAIN_MENU

PUB DisplayNotValid(localCharacter)

  repeat until not lockset(debugLock)
  Pst.str(string(13, "You entered ", 34))
  SafeChar(localCharacter)
  Pst.Char(34)
  Pst.Char(13)
  Pst.Char(34)
  SafeChar(localCharacter)
  Pst.Str(string(34, " is not a valid command."))
  Pst.str(string(13, "Please enter different command."))
  lockclr(debugLock)
  Pause(2_000)
  
PUB SafeChar(localCharacter)

  if localCharacter > LOWEST_ASCII_USED and localCharacter =< HIGHEST_ASCII_USED
    Pst.Char(localCharacter)
  else
    Pst.Char("$")
    Pst.Hex(localCharacter, 2)
    

PUB LoadText(localPtr) | localIndex, showFlag, localCharacter', eeStart', controlCount
 
  activeCharacter := 32
  stScrollIndex := 0

  repeat 
    
    if ledMode <> TEXT_MODE 
      abort
    
    localCharacter := byte[localPtr++]
    
    ' Check for control characters
    if localCharacter < 32      
      if localCharacter == SET_FONT
        activeFont := byte[localPtr++]
        'controlCount := 1
      elseif localCharacter == SET_DELAY
        horizontalScrollDelay := byte[localPtr++]
        'controlCount := 1        
      elseif localCharacter == SET_BRIGHTNESS
        brightness := byte[localPtr++]
        DisplayBrightness
      elseif localCharacter == SET_FOREGROUND_COLOR
        activeColorIndex := byte[localPtr++]
        GetColors(activeColorIndex, @characterColors)
      elseif localCharacter == SET_BACKGROUND_COLOR
        bytemove(@pBackground, @background, 3)
      elseif localCharacter == SET_FOREGROUND_RGB
        activeColorIndex := CUSTOM_COLOR
      elseif localCharacter == SET_BACKGROUND_RGB
        activeColorIndex := CUSTOM_COLOR    
    elseif localCharacter == 32
      ScrollSpace(DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS)
    else  
      previousCharacter := activeCharacter
      activeCharacter := localCharacter
      pStScrollIndex := stScrollIndex
      if activeCharacter <> previousCharacter
        BuildCharacter(activeFont, localCharacter, activeColorIndex)
      ScrollSpace(DEFAULT_SPACE_BETWEEN_LETTERS)   
      ScrollFontHorizontal
    
    if overTimeFlag
      Pst.str(string(13, "************* overTimeFlag = "))
      Pst.dec(overTimeFlag)
      Pst.str(string(" *************")) 
      overTimeFlag := 0
  while localCharacter 
       
PUB BuildCharacter(font, characterIndex, fontColor): size | widthIndex, heightIndex, rowOfFontBits, {
              } furthestRightBit, mostSigBit, bitToSubtract, wideFontIndex, {
              } localPtr, rowOfFontPtr, bitToCheck, columnIndex,{ incrementIndex
              } characterWidth, columnPtr
'' This method reads the bits making up a character and fills the buffer "fontSpace" with bytes representing
'' the various bits.
              
  bytefill(@fontSpace, 0, FONT_BYTES_IN_EEPROM)
 
  characterIndex -= LOWEST_ASCII_USED
  furthestRightBit := fontWidth[font] 'FONT_WIDTH
  characterWidth := FindCharacterWidth(font, characterIndex)
 
  if characterWidth
    characterWidth--
  else
    return  
  if fontColor == RAINBOW    
    
    columnPtr := @columnColors
    repeat result from 0 to characterWidth
      columnPtr := IncrementColors(columnPtr, @characterColors, @pseudoColorIncrement, {
      } rainbowTransitionIndex)
      
      TransitionRainbow
      
  else
    AdjustBrightness(@blackSetting + (TRI_COLOR * fontColor), @characterColors, brightness)
     
    
  

 
  rowOfFontPtr := fontPtr[font] + (characterIndex * fontHeight[font]) 
  repeat heightIndex from 0 to fontHeight[font] - 1
    
    rowOfFontBits := byte[rowOfFontPtr++]
    if heightIndex or fontColor <> RAINBOW
   
    bitToCheck := 1 << 7
    
    repeat columnIndex from 0 to characterWidth
      if heightIndex == 0 and fontColor == RAINBOW
        
      if bitToCheck & rowOfFontBits  
        localPtr := @fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
        } (TRI_COLOR * columnIndex)  
        if fontColor == RAINBOW
          columnPtr := @columnColors + (TRI_COLOR * columnIndex)
          bytemove(localPtr, columnPtr, TRI_COLOR)
          
        else
          bytemove(localPtr, @characterColors, TRI_COLOR)  
        
      bitToCheck >>= 1 
    
  
  fontSpace[FONT_BYTES_PER_CHARACTER] := size := characterWidth + 1
  
PRI TransitionRainbow

  if rainbowTransitionIndex == colorTransitions   ' colorTransitions - 1? No, zero doesn't count
    rainbowTransitionIndex := 0                   ' in this instance zero is not a transitional
    rainbowIndex := nextRainbowIndex              ' color.
    if nextRainbowIndex == LAST_RAINBOW_COLOR
      nextRainbowIndex := FIRST_RAINBOW_COLOR
    else
      nextRainbowIndex++

    bytemove(@characterColors, @nextColors, TRI_COLOR)
    GetColors(nextRainbowIndex, @nextColors)

    AdjustBrightness(@nextColors, @nextColors, brightness)   
  
    GetColors(rainbowIndex, @characterColors) 
    
    FindIncrementalColors(@characterColors, @nextColors, @pseudoColorIncrement, colorTransitions + 1)   
  else
    rainbowTransitionIndex++ 
    
PRI FindCharacterWidth(font, characterIndex) | heightIndex, lastHeightIndex, bitIndex, {
                                             } bitToCheck, rowOfBits, lowestBit, {
                                             } rowOfFontPtr, lastBitIndex

  lastHeightIndex := fontHeight[font] - 1
  lowestBit := 8          '** make generic for other possible widths.
  lastBitIndex := lowestBit - 1
  rowOfFontPtr := fontPtr[font] + (characterIndex * fontHeight[font]) 
  repeat heightIndex from 0 to lastHeightIndex 
    rowOfBits := byte[rowOfFontPtr++]
    bitToCheck := 1
    repeat bitIndex from 0 to lastBitIndex '** make generic for other possible widths.
      if bitToCheck & rowOfBits
        lowestBit := bitIndex
        lastBitIndex := lowestBit - 1
       
        quit     
      else
        bitToCheck <<= 1
    if lastBitIndex == -1
      quit
  result := 8 - lowestBit
      
PUB IncrementColors(destinationPtr, baseColorPtr, incrementalPtr, incrementIndex)

  if incrementIndex
    byte[destinationPtr][RED_PORTION] := byte[baseColorPtr][RED_PORTION] + {
    } ((long[incrementalPtr][RED_PORTION] * incrementIndex) / PSEUDO_MULTIPLIER)
    byte[destinationPtr][GREEN_PORTION] := byte[baseColorPtr][GREEN_PORTION] + {
    } ((long[incrementalPtr][GREEN_PORTION] * incrementIndex) / PSEUDO_MULTIPLIER)
    byte[destinationPtr][BLUE_PORTION] := byte[baseColorPtr][BLUE_PORTION] + {
    } ((long[incrementalPtr][BLUE_PORTION] * incrementIndex) / PSEUDO_MULTIPLIER)
  else
    bytemove(destinationPtr, baseColorPtr, TRI_COLOR)
  
  result := destinationPtr + TRI_COLOR
  
PUB DisplayColorBytes(localPtr)

  repeat until not lockset(debugLock)
  Pst.char("$")
  Pst.hex(byte[localPtr][RED_PORTION], 2)
  Pst.str(string(", $"))
  Pst.hex(byte[localPtr][GREEN_PORTION], 2)  
  Pst.str(string(", $")) 
  Pst.hex(byte[localPtr][BLUE_PORTION], 2)  
  lockclr(debugLock)  
  
PUB FindIncrementalColors(initialColorsPtr, finalColorsPtr, incrementalPtr, localSize)
'' localSize should include the initialColor but not finalColor.
'' The debug lock should be set prior to calling this method.

  ' find incremental color change
  ' use the "PSEUDO_MULTIPLIER" mulitplier to reduce rounding errors
  ' Note we divide by multiplier prior to assigning color
  ' to buffer.
  repeat result from 0 to 2
    long[incrementalPtr][result] := ((byte[finalColorsPtr][result] - {
    } byte[initialColorsPtr][result])* PSEUDO_MULTIPLIER) / localSize 
  
PUB AdjustBrightness(initialColorPtr, finalColorPtr, localBrightness)

  byte[finalColorPtr + RED_PORTION] := (byte[initialColorPtr + RED_PORTION] * {
  } localBrightness) / MAX_BRIGHTNESS
  byte[finalColorPtr + GREEN_PORTION] := (byte[initialColorPtr + GREEN_PORTION] * {
  }localBrightness) / MAX_BRIGHTNESS
  byte[finalColorPtr + BLUE_PORTION] := (byte[initialColorPtr + BLUE_PORTION] * {
  } localBrightness) / MAX_BRIGHTNESS
 
PUB ScrollSpace(localSize) | dataToScrollIndex, displayRowIndex, firstByteOfRowPtr, lastOfRowIndex

  {repeat until not lockset(debugLock)
  Pst.str(string(13, "ScrollSpace("))
  Pst.dec(localSize)
  Pst.Char(")")
  lockclr(debugLock)  }
      
  localSize--
  repeat dataToScrollIndex from 0 to localSize
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      firstByteOfRowPtr := @displayBuffer + (displayRowIndex * DISPLAY_BYTES_WIDTH)
      lastOfRowIndex := (displayRowIndex * DISPLAY_BYTES_WIDTH) + {
        } DISPLAY_BYTES_WIDTH - TRI_COLOR
      bytemove(firstByteOfRowPtr, firstByteOfRowPtr + TRI_COLOR, DISPLAY_BYTES_WIDTH - TRI_COLOR)
      bytemove(@displayBuffer + lastOfRowIndex, @background, TRI_COLOR)
     
    IncrementTime(horizontalScrollDelay)
                                                                                 
PUB ScrollFontHorizontal| dataToScrollIndex, displayRowIndex, firstByteOfRowPtr, {
                        } lastOfRowIndex, fontColumnToDisplay, localSize

  localSize := fontSpace[FONT_BYTES_PER_CHARACTER]
  repeat dataToScrollIndex from 0 to localSize - 1
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      if ledMode <> TEXT_MODE 'and ledMode <> RAINBOW_TEXT_MODE
        abort
      firstByteOfRowPtr := @displayBuffer + (displayRowIndex * DISPLAY_BYTES_WIDTH)
      lastOfRowIndex := (displayRowIndex * DISPLAY_BYTES_WIDTH) + {
        } DISPLAY_BYTES_WIDTH - TRI_COLOR
      fontColumnToDisplay := (displayRowIndex * FONT_EEPROM_BYTE_WIDTH) + {
        } (dataToScrollIndex * TRI_COLOR) 
      bytemove(firstByteOfRowPtr, firstByteOfRowPtr + ledType, DISPLAY_BYTES_WIDTH - TRI_COLOR)
      bytemove(@displayBuffer + lastOfRowIndex, @fontSpace + fontColumnToDisplay, TRI_COLOR)
     
    IncrementTime(horizontalScrollDelay)
  pActiveFont := activeFont
  pactiveColorIndex := activeColorIndex

PUB CombineFlags

  result := modifiableColorFlag << 2
  result += modifiableNumberFlag << 1
  result += modifiableBrightnessFlag

PRI LightLeds | timeInterval, localPreviousMode, previousColor, previousBrightness, {
              } previousActiveLeds, localSize
 
  localPreviousMode := -1
  previousColor := -1
  previousBrightness := -1
  previousActiveLeds := -1

  Rgb.Start(PIN_RX,PIN_TX, 19200)    
  
 
  ledCog := Led.Start(FIRST_ANODE_PIN, SHIFT_CLOCK, SHIFT_LATCH, SHIFT_DATA, @displayBuffer) - 1
  
  repeat
   
    if ledMode <> localPreviousMode or activeColorIndex <> previousColor or {
     } brightness <> previousBrightness or activeLeds <> previousActiveLeds                  
      localPreviousMode := ledMode
      previousColor := activeColorIndex
      previousBrightness := brightness
      previousActiveLeds := activeLeds
      case ledMode         
        OFF_MODE:
         
          bytefill(@displayBuffer, 0, DISPLAY_BYTES)
        
        PULSE_MODE:
          Pulse         
      
        PATTERN_MODE:
          Pattern
        CYCLE_MODE:
          CycleColors 
        TEXT_MODE:
          localSize := strsize(@messageBuffer)
          ScrollMessage(@messageBuffer, localSize)

PUB Pulse | localColor, {localBrightness, localActiveLeds, pulseIndex,} localLightLevel

  localColor := activeColorIndex
  if localColor == RAINBOW
    activeColorIndex := WHITE
  'localBrightness := brightness
  'localActiveLeds := activeLeds

  StartIncrementTimer
  repeat
    repeat localLightLevel from MIN_BRIGHTNESS to brightness - 1 step MIN_BRIGHTNESS / 2 
      FillDisplay(activeColorIndex, localLightLevel)
      IncrementTime(horizontalScrollDelay)
      'DumpBuffer(@displayBuffer, DISPLAY_BYTES, 24)    
    repeat localLightLevel from brightness to MIN_BRIGHTNESS + 1 step MIN_BRIGHTNESS / 2   
      FillDisplay(activeColorIndex, localLightLevel)
      IncrementTime(horizontalScrollDelay)
      'DumpBuffer(@displayBuffer, DISPLAY_BYTES, 24)      
  while ledMode == PULSE_MODE   
 
PUB CycleColors | localBrightness, colorIndex, brightnessIndex, localColor[TRI_COLOR], {
                } localCurrentColor[TRI_COLOR], localNextColor[TRI_COLOR], {
                } localIncremental[TRI_COLOR], localTransitions, localDirection

  'localBrightness := brightness
  localTransitions := colorTransitions + 1
  StartIncrementTimer
  localDirection := -1
  repeat
    repeat colorIndex from FIRST_RAINBOW_COLOR to LAST_RAINBOW_COLOR
      GetColors(colorIndex, @localCurrentColor)
      if colorIndex == LAST_RAINBOW_COLOR
        GetColors(FIRST_RAINBOW_COLOR, @localNextColor)
      else
        GetColors(colorIndex + 1, @localNextColor)
      FindIncrementalColors(@localCurrentColor, @localNextColor, @localIncremental, localTransitions)  
      
      repeat result from 0 to localTransitions
        IncrementTime(horizontalScrollDelay)
        IncrementColors(@localColor, @localCurrentColor, @localIncremental, {
      } result)
        FillDisplayPtr(@localColor, brightness)
        if ledMode <> CYCLE_MODE 'or brightness <> localBrightness
          return
    if localTransitions == 0
      localDirection := 1
    elseif localTransitions == colorTransitions + 1
      localDirection := -1
    localTransitions += localDirection   
  while ledMode == CYCLE_MODE 'and brightness == localBrightness

PUB FillDisplayPtr(colorPtr, brightnessIndex) | ledIndex
' return how far past end of buffer color data was written.
' this vaule should be zero

  AdjustBrightness(colorPtr, @displayBuffer, brightnessIndex)
  result := @displayBuffer + TRI_COLOR
  repeat DISPLAY_WIDTH_PIXELS - 1
    bytemove(result, @displayBuffer, TRI_COLOR)
    result += TRI_COLOR
  repeat ARRAY_HEIGHT - 1 
    bytemove(result, @displayBuffer, DISPLAY_WIDTH_PIXELS * TRI_COLOR)
    result += DISPLAY_WIDTH_PIXELS * TRI_COLOR
  result -= @displayBuffer
  
PUB FillDisplay(colorIndex, brightnessIndex) | localColors[TRI_COLOR]
' return how far past end of buffer color data was written.
' this vaule may not be zero

  GetColors(colorIndex, @localColors) 
  result := FillDisplayPtr(@localColors, brightnessIndex)
  

PUB Pattern | localBrightness, direction

  localBrightness := brightness
  direction := 1
  
  repeat
    repeat result from 200 to 50 step 10
      \PatternCycle(result, direction)
      if ledMode <> PATTERN_MODE or brightness <> localBrightness
        return
    repeat result from 60 to 190 step 10
      \PatternCycle(result, direction)
      if ledMode <> PATTERN_MODE or brightness <> localBrightness
        return
    direction *= -1
  while ledMode == PATTERN_MODE and brightness == localBrightness

PUB PatternCycle(betweenPatternDelay, direction)
' Fix so any size display will work
  'repeat until not lockset(debugLock)
  if direction > 0
    repeat result from 0 to 11
      bytemove(@displayBuffer, @patternD00 + (result * DISPLAY_BYTES), DISPLAY_BYTES)
      pause(betweenPatternDelay)
      if ledMode <> PATTERN_MODE
        abort        
  else
    repeat result from 11 to 0
      bytemove(@displayBuffer, @patternD00 + (result * DISPLAY_BYTES), DISPLAY_BYTES)
      pause(betweenPatternDelay)  
      if ledMode <> PATTERN_MODE
        abort
   
PUB ScrollMessage(localPtr, localSize)

  StartIncrementTimer
  repeat
    \LoadText(localPtr)
  while ledMode == TEXT_MODE     

PUB Pause(ms) | t

'' Delay program in milliseconds

  if (ms < 1)                                                   ' delay must be > 0
    return
  else
    t := cnt - 1792                                             ' sync with system counter
    repeat ms                                                   ' run delay
      waitcnt(t += MS_001)
    
PUB StartIncrementTimer

  overTimeFlag := 0         
  incrementTimer := cnt
  
PUB IncrementTime(increment)

  result := cnt
  if result - incrementTimer > increment
    overTimeFlag := 1           ' a loop took too long.
    incrementTimer := result
  else
    repeat
      result := cnt
    while result - incrementTimer < increment
    incrementTimer := result
    
PRI SetSpeed(localSpeed)

  ||localSpeed  ' only postive speed for now
  localSpeed--
  result := speedToDelay[localSpeed]
  result *= MS_001 
  
PRI DisplaySpeed

  repeat until not lockset(debugLock) 
  Pst.str(string(Pst#PC, SPEED_DISPLAY_X, SPEED_DISPLAY_Y, {
  } "scroll speed = "))
  Pst.dec(scrollSpeed)
  Pst.ClearEnd
  lockclr(debugLock)

PRI DisplayBrightness

  repeat until not lockset(debugLock)
  Pst.str(string(Pst#PC, ACTIVE_BRIGHTNESS_DISPLAY_X, ACTIVE_BRIGHTNESS_DISPLAY_Y, {
  } "brightness = "))
  Pst.dec(brightness)
  Pst.ClearEnd
  lockclr(debugLock)
    
PRI DisplayColor

  repeat until not lockset(debugLock)
  Pst.str(string(Pst#PC, ACTIVE_COLOR_DISPLAY_X, ACTIVE_COLOR_DISPLAY_Y, {
  } "active color = "))    
  Pst.str(GetColorName(activeColorIndex))
  Pst.ClearEnd
  lockclr(debugLock)
    
PRI DisplayActiveNumber

  repeat until not lockset(debugLock)
  Pst.str(string(Pst#PC, ACTIVE_LEDS_DISPLAY_X, ACTIVE_LEDS_DISPLAY_Y, {
  } "number of active LEDs = "))    
  Pst.dec(activeLeds)
  Pst.ClearEnd
  lockclr(debugLock)
    
PRI DisplayMode

  repeat until not lockset(debugLock)
  Pst.str(string(Pst#PC, MODE_DISPLAY_X, MODE_DISPLAY_Y, {
  } "LED mode = "))    
  Pst.str(GetModeName(ledMode))
  Pst.ClearEnd 
  lockclr(debugLock)

PRI DisplayTitle

  repeat until not lockset(debugLock)
  Pst.Clear
  Pst.Position(TITLE_X, TITLE_Y)
  Pst.str(string("8 x 8 RGB LED Array Demo"))
  Pst.ClearEnd
  Pst.Position(TITLE_X, TITLE_Y + 2)
  Pst.str(string("program name of top object = "))
  Pst.str(@programName)
  Pst.ClearEnd
  lockclr(debugLock)

PUB DisplayInfo

  repeat until not lockset(debugLock)
  Pst.Clear
  lockclr(debugLock)
  DisplayTitle
  DisplayMode
  DisplayActiveNumber
  DisplayColor
  DisplayBrightness
  DisplaySpeed
  
{PRI GetActiveColorName

  result := GetColorName(activeColorIndex)
}  
PRI GetActiveFontName

  case activeFont
    FREE_DESIGN:
      result := string("FREE_DESIGN")
    SIMPLYTRONICS_0508:
      result := string("SIMPLYTRONICS_0508")
    'SIMPLYTRONICS_0816:
    '  result := string("SIMPLYTRONICS_0816")
          
PRI GetModeName(localMode)

  case localMode        
    OFF_MODE:
      result := string("OFF_MODE")
    LARSON_MODE:
      result := string("LARSON_MODE")        
    SOLID_MODE:
      result := string("SOLID_MODE")
    DRAGON_MODE:
      result := string("DRAGON_MODE")
    TAIL_MODE:
      result := string("TAIL_MODE")
    ROTATE_MODE:
      result := string("ROTATE_MODE")
    PULSE_MODE:
      result := string("PULSE_MODE")
    BOW_MODE:
      result := string("BOW_MODE")
    PATTERN_MODE:
      result := string("PATTERN_MODE")
    CYCLE_MODE:
      result := string("CYCLE_MODE")
    TEXT_MODE:
      result := string("TEXT_MODE")
    UPDATE_TEXT_MODE:
      result := string("UPDATE_TEXT_MODE")
    WHITE_MODE:
      result := string("WHITE_MOD")
    RAINBOW_ANGLED_MODE:
      result := string("RAINBOW_ANGLED_MODE")
    CYCLE_TEXT_MODE:
      result := string("CYCLE_TEXT_MODE")
    other:
      result := string("other mode")

PRI GetColorName(localColor)

  case localColor
    BLACK:
      result := string("BLACK")
    RED:
      result := string("RED")
    ORANGE:
      result := string("ORANGE")
    YELLOW:
      result := string("YELLOW")
    GREEN:
      result := string("GREEN")
    BLUE:
      result := string("BLUE")
    INDIGO:
      result := string("INDIGO")
    VIOLET:
      result := string("VIOLET")
    WHITE:
      result := string("WHITE")
    RAINBOW:
      result := string("RAINBOW")
    other:
      result := string("other")
      
PUB DumpBuffer(localPtr, localSize, localColumns) | bufferIndex

  repeat until not lockset(debugLock)
  Pst.Position(TITLE_X, BUFFER_DUMP_Y)
  Pst.str(string("displayBuffer buffer dump:", 13))
  repeat bufferIndex from 0 to localSize - 1
    if bufferIndex // localColumns == 0
      Pst.Char(13)
    Pst.Char(32)  
    Pst.Char("$")  
    Pst.hex(byte[localPtr + bufferIndex], 2)
  lockclr(debugLock)

PRI GetColors(colorIndex, colorsPtr)

  bytemove(colorsPtr, @blackSetting + (colorIndex * TRI_COLOR), TRI_COLOR)


DAT
' color enumeration tri color LEDs
'  #0, BLACK, RED, ORANGE, YELLOW, GREEN, BLUE, VIOLET, WHITE, CYAN, INDIGO, CUSTOM_COLOR

pBackground             byte 0, 0, 0
background              byte 0, 0, 0
blackSetting            byte 0, 0, 0   
redSetting              byte RED_R, RED_G, RED_B
orangeSetting           byte ORANGE_R, ORANGE_G, ORANGE_B
yellowSetting           byte YELLOW_R, YELLOW_G, YELLOW_B
greenSetting            byte GREEN_R, GREEN_G, GREEN_B
blueSetting             byte BLUE_R, BLUE_G, BLUE_B
violetSetting           byte VIOLET_R, VIOLET_G, VIOLET_B
whiteSetting            byte 255, 255, 255 'WHITE_R, WHITE_G, WHITE_B
cyanSetting             byte CYAN_R, CYAN_G, CYAN_B
indigoSetting           byte INDIGO_R, INDIGO_G, INDIGO_B
customSetting           byte 0[3]
extraBytes              byte 0[3]


DAT

              
mainMenuText            byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                          ' clear to bottom of screen
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                       
                        byte Pst#PX, MENU_DISPLAY_X, "   Select a Mode.", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "S) Stop / Off (all LEDs off)", 13
                      
                        byte Pst#PX, MENU_DISPLAY_X, "P) Pulse (buffer pulses)", 13 
                        byte Pst#PX, MENU_DISPLAY_X, "A) Cycling Pattern", 13  
                        byte Pst#PX, MENU_DISPLAY_X, "L) Cycling Colors", 13
                        byte Pst#PX, MENU_DISPLAY_X, "T) Scroll Text", 13
                        byte Pst#PX, MENU_DISPLAY_X, "X) Display Rainbow Text", 13', 0
                        byte Pst#PX, MENU_DISPLAY_X, 13, "   Or Select a Color.", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "R) Red", 13
                        byte Pst#PX, MENU_DISPLAY_X, "O) Orange", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Y) Yellow", 13
                        byte Pst#PX, MENU_DISPLAY_X, "G) Green", 13
                        byte Pst#PX, MENU_DISPLAY_X, "B) Blue", 13
                        byte Pst#PX, MENU_DISPLAY_X, "V) Violet (really purple)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "W) White", 13
                        byte Pst#PX, MENU_DISPLAY_X, 13, "   Other Actions", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "+) Small Brightness Increase", 13
                        byte Pst#PX, MENU_DISPLAY_X, "*) Large Brightness Increase", 13
                        byte Pst#PX, MENU_DISPLAY_X, "-) Small Brightness Decrease", 13
                        byte Pst#PX, MENU_DISPLAY_X, "/) Large Brightness Decrease", 13
                        byte Pst#PX, MENU_DISPLAY_X, "6) Small Scroll Speed Increase", 13
                        byte Pst#PX, MENU_DISPLAY_X, "8) Large Scroll Speed Increase", 13
                        byte Pst#PX, MENU_DISPLAY_X, "4) Small Scroll Speed Decrease", 13
                        byte Pst#PX, MENU_DISPLAY_X, "2) Large Scroll Speed Decrease", 13
                        byte Pst#PX, MENU_DISPLAY_X, "0) ", 34, "Free Design", 34, " Font", 13
                        byte Pst#PX, MENU_DISPLAY_X, "1) ", 34, "SimplyTronics", 34, " 5 x 8 Font", 13, 0
 
DAT freeDesign032       byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign033           byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %00000000
                        byte %11000000
              
freeDesign034           byte %10100000
                        byte %10100000
                        byte %10100000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                         
freeDesign035           byte %01010000
                        byte %11111000
                        byte %01010000
                        byte %11111000
                        byte %01010000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign036           byte %01000000
                        byte %01110000
                        byte %11000000
                        byte %11100000
                        byte %01110000
                        byte %00110000
                        byte %11100000
                        byte %01000000
              
freeDesign037           byte %01111100
                        byte %10100100
                        byte %10100100
                        byte %01001000
                        byte %00010010
                        byte %00100101
                        byte %00100101
                        byte %00100010
              
freeDesign038           byte %00111100
                        byte %01100100
                        byte %01100000
                        byte %00110000
                        byte %01000110
                        byte %11001100
                        byte %11001100
                        byte %01110110
              
freeDesign039           byte %10000000
                        byte %10000000
                        byte %10000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign040           byte %00100000
                        byte %01000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %01000000
                        byte %00100000

freeDesign041           byte %10000000
                        byte %01000000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01000000
                        byte %10000000
                         
freeDesign042           byte %00000000
                        byte %00000000
                        byte %00100000
                        byte %10101000
                        byte %01110000
                        byte %10101000
                        byte %00100000
                        byte %00000000

freeDesign043           byte %00000000
                        byte %00000000
                        byte %00100000
                        byte %00100000
                        byte %11111000
                        byte %00100000
                        byte %00100000
                        byte %00000000

freeDesign044           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %01000000
                        byte %10000000
              
freeDesign045           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11100000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
              
freeDesign046           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
              
freeDesign047           byte %00010000
                        byte %00010000
                        byte %00100000
                        byte %00100000
                        byte %01000000
                        byte %01000000
                        byte %10000000
                        byte %10000000
              
freeDesign048           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11101100
                        byte %11011100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign049           byte %01100000
                        byte %11100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
              
freeDesign050           byte %01110000
                        byte %10011000
                        byte %00011000
                        byte %00011000
                        byte %00110000
                        byte %01100000
                        byte %11000000
                        byte %11111000
              
freeDesign051           byte %01110000
                        byte %10011000
                        byte %00011000
                        byte %01110000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %11110000
              
freeDesign052           byte %00011000
                        byte %00011000
                        byte %01011000
                        byte %01011000
                        byte %10011000
                        byte %11111100
                        byte %00011000
                        byte %00011000
              
freeDesign053           byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11110000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %11110000
              
freeDesign054           byte %00111000
                        byte %01000000
                        byte %11000000
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign055           byte %11111100
                        byte %00001100
                        byte %00011000
                        byte %00011000
                        byte %00110000
                        byte %00110000
                        byte %01100000
                        byte %01100000
              
freeDesign056           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign057           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00001100
                        byte %00011000
                        byte %01110000
              
freeDesign058           byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
                        byte %00000000

freeDesign059           byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
                        byte %00000000
                        byte %11000000
                        byte %01000000
                        byte %10000000
                         
freeDesign060           byte %00000000
                        byte %00110000
                        byte %01100000
                        byte %11000000
                        byte %11000000
                        byte %01100000
                        byte %00110000
                        byte %00000000
              
freeDesign061           byte %00000000
                        byte %00000000
                        byte %11100000
                        byte %00000000
                        byte %11100000
                        byte %00000000
                        byte %00000000
                        byte %00000000
              
freeDesign062           byte %00000000
                        byte %11000000
                        byte %01100000
                        byte %00110000
                        byte %00110000
                        byte %01100000
                        byte %11000000
                        byte %00000000
              
freeDesign063           byte %11111000
                        byte %11001100
                        byte %00001100
                        byte %00011000
                        byte %00110000
                        byte %00100000
                        byte %00000000
                        byte %00110000
              
freeDesign064           byte %00111110
                        byte %01000001
                        byte %10011101
                        byte %10100101
                        byte %10100101
                        byte %10111111
                        byte %01000000
                        byte %00111110
              
freeDesign065           byte %00110000
                        byte %00110000
                        byte %00111000
                        byte %01011000
                        byte %01011000
                        byte %11111100
                        byte %10001100
                        byte %10001100
              
freeDesign066           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
              
freeDesign067           byte %01111000
                        byte %11001000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11001000
                        byte %01110000
              
freeDesign068           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
              
freeDesign069           byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11111000
                         
freeDesign070           byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
              
freeDesign071           byte %01111100
                        byte %11000100
                        byte %11000000
                        byte %11000000
                        byte %11011100
                        byte %11001100
                        byte %11001100
                        byte %01110100
                         
freeDesign072           byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
              
freeDesign073           byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign074           byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %10011000
                        byte %01110000
              
freeDesign075           byte %11000100
                        byte %11001000
                        byte %11010000
                        byte %11110000
                        byte %11011000
                        byte %11011000
                        byte %11001100
                        byte %11001100
              
freeDesign076           byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11111000
                         
freeDesign077           byte %11000110
                        byte %11000110
                        byte %11101110
                        byte %11101110
                        byte %10110110
                        byte %10110110
                        byte %10000110
                        byte %10000110
              
freeDesign078           byte %11001000 
                        byte %11001000
                        byte %11101000
                        byte %11101000
                        byte %10111000
                        byte %10111000
                        byte %10011000
                        byte %10011000
              
freeDesign079           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign080           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                         
freeDesign081           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %00001110
                         
freeDesign082           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
              
freeDesign083           byte %01111000
                        byte %11001000
                        byte %11100000
                        byte %01110000
                        byte %00111000
                        byte %00011000
                        byte %10011000
                        byte %11110000
              
freeDesign084           byte %11111100
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign085           byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign086           byte %11000100
                        byte %11000100
                        byte %01101000
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign087           byte %11000001
                        byte %11000001
                        byte %01101001
                        byte %01101101
                        byte %01101101
                        byte %00110011
                        byte %00110011
                        byte %00110011
              
freeDesign088           byte %11001000
                        byte %11001000
                        byte %01110000
                        byte %01100000
                        byte %00110000
                        byte %01110000
                        byte %10011000
                        byte %10011000
              
freeDesign089           byte %11000100
                        byte %11000100
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign090           byte %11111000
                        byte %00011000
                        byte %00110000
                        byte %00110000
                        byte %01100000
                        byte %01100000
                        byte %11000000
                        byte %11111000
              
freeDesign091           byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11110000

freeDesign092           byte %00000000
                        byte %11000000
                        byte %01100000
                        byte %01100000
                        byte %00110000
                        byte %00110000
                        byte %00011000
                        byte %00000000

freeDesign093           byte %11110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %11110000
                         
freeDesign094           byte %00000000
                        byte %00000000
                        byte %00100000
                        byte %01010000
                        byte %10001000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign095           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11111111
                         
freeDesign096           byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %01100000
                        byte %00110000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign097           byte %00000000
                        byte %01111000
                        byte %00001100
                        byte %01111100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00000000
                         
freeDesign098           byte %11000000
                        byte %11000000
                        byte %11111000
                        byte %11001100 
                        byte %11001100 
                        byte %11001100
                        byte %11111000
                        byte %00000000

freeDesign099           byte %00000000
                        byte %01111000
                        byte %11001000
                        byte %11000000
                        byte %11000000
                        byte %11001000
                        byte %01110000
                        byte %00000000

freeDesign100           byte %00001100
                        byte %00001100
                        byte %01111100
                        byte %11001100 
                        byte %11001100 
                        byte %11001100 
                        byte %01111100
                        byte %00000000

freeDesign101           byte %00000000
                        byte %01111000
                        byte %11001100
                        byte %11011000
                        byte %11100000
                        byte %11000100
                        byte %01111000
                        byte %00000000
              
freeDesign102           byte %00111000
                        byte %01100000
                        byte %11110000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %00000000
                         
freeDesign103           byte %00000000
                        byte %11111110
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00001100
                        byte %01111000
                         
freeDesign104           byte %11000000
                        byte %11000000
                        byte %11011000
                        byte %11101100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %00000000

freeDesign105           byte %11000000 
                        byte %00000000
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000
                        byte %00000000

freeDesign106           byte %01100000 
                        byte %00000000
                        byte %01100000 
                        byte %01100000 
                        byte %01100000 
                        byte %01100000
                        byte %01100000
                        byte %11000000

freeDesign107           byte %11000000 
                        byte %11000100 
                        byte %11001000 
                        byte %11010000 
                        byte %11110000 
                        byte %11011000 
                        byte %11001100
                        byte %00000000

freeDesign108           byte %11000000 
                        byte %11000000
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000
                        byte %00000000

freeDesign109           byte %00000000
                        byte %11010010
                        byte %11111111
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %00000000

freeDesign110           byte %00000000
                        byte %11011000
                        byte %11101100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %00000000

freeDesign111           byte %00000000
                        byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %00000000

freeDesign112           byte %00000000
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11000000
                        byte %11000000
                         
freeDesign113           byte %00000000
                        byte %01111100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00001100
                        byte %00001100
              
freeDesign114           byte %00000000
                        byte %11010000
                        byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %00000000

freeDesign115           byte %00000000
                        byte %01110000
                        byte %11000000
                        byte %11100000
                        byte %01110000
                        byte %00110000
                        byte %11100000
                        byte %00000000

freeDesign116           byte %01100000
                        byte %01100000
                        byte %11110000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
              
freeDesign117           byte %00000000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %00000000
                         
freeDesign118           byte %00000000
                        byte %11001100
                        byte %11001100
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00110000
                        byte %00000000

freeDesign119           byte %00000000
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %01101100
                        byte %01101100
                        byte %00000000
              
freeDesign120           byte %00000000
                        byte %11001100
                        byte %11101000
                        byte %01110000
                        byte %00111000
                        byte %01011100
                        byte %11001100
                        byte %00000000

freeDesign121           byte %00000000
                        byte %11001100
                        byte %11001100
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00010000
                        byte %01110000
              
freeDesign122           byte %00000000
                        byte %11110000
                        byte %00110000
                        byte %01100000
                        byte %01100000
                        byte %11000000
                        byte %11110000
                        byte %00000000
              
freeDesign123           byte %00111000
                        byte %01100000
                        byte %01100000
                        byte %11000000
                        byte %11000000
                        byte %01100000
                        byte %01100000
                        byte %00111000
                         
freeDesign124           byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
              
freeDesign125           byte %11100000
                        byte %00110000
                        byte %00110000
                        byte %00011000
                        byte %00011000
                        byte %00110000
                        byte %00110000
                        byte %11100000
              
freeDesign126           byte %00000000
                        byte %00000000
                        byte %01110000
                        byte %10011001
                        byte %00001110
                        byte %00000000
                        byte %00000000
                        byte %00000000

DAT
'--------------------------------- [ ASCII ]--------------------------------------
'----------------------------------[  5x8  ]--------------------------------------
DAT ASCII_0508_032 byte    $00,$00,$00,$00,$00,$00,$00,$00    ' - -           
ASCII_0508_033 byte        $20,$20,$20,$20,$20,$00,$20,$00    ' -!-           
ASCII_0508_034 byte        $50,$50,$50,$00,$00,$00,$00,$00    ' -"-           
ASCII_0508_035 byte        $50,$50,$F8,$50,$F8,$50,$50,$00    ' -#-           
ASCII_0508_036 byte        $20,$78,$C0,$70,$28,$F0,$20,$00    ' -$-           
ASCII_0508_037 byte        $C0,$C8,$10,$20,$40,$98,$18,$00    ' -%-           
ASCII_0508_038 byte        $40,$A0,$A0,$40,$A8,$90,$68,$00    ' -&-           
ASCII_0508_039 byte        $30,$20,$40,$00,$00,$00,$00,$00    ' -'-           
ASCII_0508_040 byte        $10,$20,$40,$40,$40,$20,$10,$00    ' -(-           
ASCII_0508_041 byte        $40,$20,$10,$10,$10,$20,$40,$00    ' -)-           
ASCII_0508_042 byte        $20,$A8,$70,$20,$70,$A8,$20,$00    ' -*-           
ASCII_0508_043 byte        $20,$20,$20,$F8,$20,$20,$20,$00    ' -+-           
ASCII_0508_044 byte        $00,$00,$00,$00,$60,$40,$80,$00    ' -,-           
ASCII_0508_045 byte        $00,$00,$00,$F8,$00,$00,$00,$00    ' ---           
ASCII_0508_046 byte        $00,$00,$00,$00,$00,$60,$60,$00    ' -.-           
ASCII_0508_047 byte        $00,$08,$10,$20,$40,$80,$00,$00    ' -/-           
ASCII_0508_048 byte        $70,$88,$98,$A8,$C8,$88,$70,$00    ' -0-           
ASCII_0508_049 byte        $20,$60,$20,$20,$20,$20,$70,$00    ' -1-           
ASCII_0508_050 byte        $70,$88,$08,$30,$40,$80,$F8,$00    ' -2-           
ASCII_0508_051 byte        $F8,$08,$10,$30,$08,$88,$70,$00    ' -3-           
ASCII_0508_052 byte        $10,$30,$50,$90,$F8,$10,$10,$00    ' -4-           
ASCII_0508_053 byte        $F8,$80,$F0,$08,$08,$88,$70,$00    ' -5-           
ASCII_0508_054 byte        $38,$40,$80,$F0,$88,$88,$70,$00    ' -6-           
ASCII_0508_055 byte        $F8,$08,$10,$20,$40,$40,$40,$00    ' -7-           
ASCII_0508_056 byte        $70,$88,$88,$70,$88,$88,$70,$00    ' -8-           
ASCII_0508_057 byte        $70,$88,$88,$78,$08,$10,$E0,$00    ' -9-           
ASCII_0508_058 byte        $00,$60,$60,$00,$60,$60,$00,$00    ' -:-           
ASCII_0508_059 byte        $00,$60,$60,$00,$60,$60,$80,$00    ' -;-           
ASCII_0508_060 byte        $10,$20,$40,$80,$40,$20,$10,$00    ' -<-           
ASCII_0508_061 byte        $00,$00,$F8,$00,$F8,$00,$00,$00    ' -=-           
ASCII_0508_062 byte        $40,$20,$10,$08,$10,$20,$40,$00    ' ->-           
ASCII_0508_063 byte        $70,$88,$10,$20,$20,$00,$20,$00    ' -?-           
ASCII_0508_064 byte        $70,$88,$B8,$A8,$B8,$80,$78,$00    ' -@-           
ASCII_0508_065 byte        $20,$50,$88,$88,$F8,$88,$88,$00    ' -A-           
ASCII_0508_066 byte        $F0,$88,$88,$F0,$88,$88,$F0,$00    ' -B-           
ASCII_0508_067 byte        $70,$88,$80,$80,$80,$88,$70,$00    ' -C-           
ASCII_0508_068 byte        $F0,$88,$88,$88,$88,$88,$F0,$00    ' -D-           
ASCII_0508_069 byte        $F8,$80,$80,$F0,$80,$80,$F8,$00    ' -E-           
ASCII_0508_070 byte        $F8,$80,$80,$F0,$80,$80,$80,$00    ' -F-           
ASCII_0508_071 byte        $70,$88,$80,$80,$B8,$88,$78,$00    ' -G-           
ASCII_0508_072 byte        $88,$88,$88,$F8,$88,$88,$88,$00    ' -H-           
ASCII_0508_073 byte        $70,$20,$20,$20,$20,$20,$70,$00    ' -I-           
ASCII_0508_074 byte        $38,$10,$10,$10,$10,$90,$60,$00    ' -J-           
ASCII_0508_075 byte        $88,$90,$A0,$C0,$A0,$90,$88,$00    ' -K-           
ASCII_0508_076 byte        $80,$80,$80,$80,$80,$80,$F8,$00    ' -L-           
ASCII_0508_077 byte        $88,$D8,$A8,$A8,$88,$88,$88,$00    ' -M-           
ASCII_0508_078 byte        $88,$88,$C8,$A8,$98,$88,$88,$00    ' -N-           
ASCII_0508_079 byte        $70,$88,$88,$88,$88,$88,$70,$00    ' -O-           
ASCII_0508_080 byte        $F0,$88,$88,$F0,$80,$80,$80,$00    ' -P-           
ASCII_0508_081 byte        $70,$88,$88,$88,$A8,$90,$68,$00    ' -Q-           
ASCII_0508_082 byte        $F0,$88,$88,$F0,$A0,$90,$88,$00    ' -R-           
ASCII_0508_083 byte        $70,$88,$80,$70,$08,$88,$70,$00    ' -S-           
ASCII_0508_084 byte        $F8,$20,$20,$20,$20,$20,$20,$00    ' -T-           
ASCII_0508_085 byte        $88,$88,$88,$88,$88,$88,$70,$00    ' -U-           
ASCII_0508_086 byte        $88,$88,$88,$88,$88,$50,$20,$00    ' -V-           
ASCII_0508_087 byte        $88,$88,$88,$A8,$A8,$D8,$88,$00    ' -W-           
ASCII_0508_088 byte        $88,$88,$50,$20,$50,$88,$88,$00    ' -X-           
ASCII_0508_089 byte        $88,$88,$50,$20,$20,$20,$20,$00    ' -Y-           
ASCII_0508_090 byte        $F8,$08,$10,$20,$40,$80,$F8,$00    ' -Z-           
ASCII_0508_091 byte        $F0,$C0,$C0,$C0,$C0,$C0,$F0,$00    ' -[-           
ASCII_0508_092 byte        $00,$80,$40,$20,$10,$08,$00,$00    ' -\-           
ASCII_0508_093 byte        $78,$18,$18,$18,$18,$18,$78,$00    ' -]-           
ASCII_0508_094 byte        $20,$70,$A8,$20,$20,$20,$20,$00    ' -^-           
ASCII_0508_095 byte        $00,$20,$40,$F8,$40,$20,$00,$00    ' -_-           
ASCII_0508_096 byte        $20,$10,$08,$00,$00,$00,$00,$00    ' -`-           
ASCII_0508_097 byte        $00,$00,$E0,$10,$70,$90,$68,$00    ' -a-           
ASCII_0508_098 byte        $80,$80,$B0,$C8,$88,$C8,$B0,$00    ' -b-           
ASCII_0508_099 byte        $00,$00,$70,$88,$80,$80,$70,$00    ' -c-           
ASCII_0508_100 byte        $08,$08,$68,$98,$88,$98,$68,$00    ' -d-           
ASCII_0508_101 byte        $00,$00,$70,$88,$F0,$80,$70,$00    ' -e-           
ASCII_0508_102 byte        $30,$48,$40,$F0,$40,$40,$40,$00    ' -f-           
ASCII_0508_103 byte        $00,$00,$70,$88,$88,$78,$08,$F0    ' -g-           
ASCII_0508_104 byte        $80,$80,$B0,$C8,$88,$88,$88,$00    ' -h-           
ASCII_0508_105 byte        $20,$00,$00,$20,$20,$20,$20,$00    ' -i-           
ASCII_0508_106 byte        $10,$00,$00,$30,$10,$10,$10,$60    ' -j-           
ASCII_0508_107 byte        $80,$80,$90,$A0,$C0,$A0,$98,$00    ' -k-           
ASCII_0508_108 byte        $60,$20,$20,$20,$20,$20,$70,$00    ' -l-           
ASCII_0508_109 byte        $00,$00,$50,$A8,$A8,$A8,$A8,$00    ' -m-           
ASCII_0508_110 byte        $00,$00,$B0,$48,$48,$48,$48,$00    ' -n-           
ASCII_0508_111 byte        $00,$00,$70,$88,$88,$88,$70,$00    ' -o-           
ASCII_0508_112 byte        $00,$00,$F0,$88,$88,$F0,$80,$80    ' -p-           
ASCII_0508_113 byte        $00,$00,$78,$88,$88,$78,$08,$08    ' -q-           
ASCII_0508_114 byte        $00,$00,$B0,$48,$40,$40,$40,$00    ' -r-           
ASCII_0508_115 byte        $00,$00,$78,$80,$70,$08,$F0,$00    ' -s-           
ASCII_0508_116 byte        $40,$40,$F8,$40,$40,$48,$30,$00    ' -t-           
ASCII_0508_117 byte        $00,$00,$90,$90,$90,$90,$68,$00    ' -u-           
ASCII_0508_118 byte        $00,$00,$88,$88,$88,$50,$20,$00    ' -v-           
ASCII_0508_119 byte        $00,$00,$A8,$A8,$A8,$A8,$50,$00    ' -w-           
ASCII_0508_120 byte        $00,$00,$88,$50,$20,$50,$88,$00    ' -x-           
ASCII_0508_121 byte        $00,$00,$88,$88,$98,$68,$08,$F0    ' -y-           
ASCII_0508_122 byte        $00,$00,$F8,$10,$20,$40,$F8,$00    ' -z-           
ASCII_0508_123 byte        $20,$40,$40,$80,$40,$40,$20,$00    ' -{-           
ASCII_0508_124 byte        $20,$20,$20,$00,$20,$20,$20,$00    ' -|-           
ASCII_0508_125 byte        $20,$10,$10,$08,$10,$10,$20,$00    ' -}-           
ASCII_0508_126 byte        $00,$00,$40,$A8,$10,$00,$00,$00    ' -~-           
ASCII_0508_127 byte        $A8,$50,$A8,$50,$A8,$50,$A8,$00    ' --



DAT 'speed to delay lookup table

speedToDelay            long 2000, 1951, 1904, 1857, 1811, 1765, 1721, 1677, 1635, 1593
                        long 1551, 1511, 1471, 1432, 1394, 1357, 1320, 1284, 1249, 1214
                        long 1180, 1147, 1115, 1083, 1051, 1021, 991, 961, 933, 904
                        long 877, 850, 824, 798, 772, 748, 723, 700, 677, 654
                        long 632, 610, 589, 569, 549, 529, 510, 491, 473, 455
                        long 438, 421, 404, 388, 373, 358, 343, 328, 314, 301
                        long 287, 275, 262, 250, 238, 227, 216, 205, 194, 184
                        long 175, 165, 156, 147, 139, 131, 123, 115, 108, 101
                        long 94, 88, 82, 76, 70, 65, 59, 55, 50, 46
                        long 41, 37, 34, 30, 27, 24, 21, 18, 16, 14
extraJustIncase         long 12, 10, 8, 6, 4, 3, 2, 1, 0
                        
DAT fontSpace           byte 0[FONT_BYTES_IN_EEPROM]
scratchSpace            byte 0[FONT_BYTES_IN_EEPROM] ' some empty bytes for between character space
     
DAT patternD00          byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B
                        
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B


                        
patternD01              byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B
                        

patternD02              byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        


patternD03              byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B


patternD04              byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        

patternD05              byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        
                        {byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B
                        }
                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B


patternD06              byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        


patternD07              byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        
                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        
                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        
                        
patternD08              byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        
                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        

                        
patternD09              byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        
                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        
patternD10              byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        
                        
patternD11              byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B
                      

patternS01              byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                             '         1         2         3         4         5         6
                             '1234567890123456789012345678901234567890123456789012345678901     
DAT messageBuffer       byte "Parallax Propeller driving 8X8 RGB LED array. LEDs are fun!   ",0[LARGEST_TEXT_MESSAGE - 61]
                             '1234567890123456789012345678901234567890123456789012345678901
    
DAT messageBuffer0      byte SF, SIMPLYTRONICS_0508, SD, 100, SB, 64, SFC, WHITE, "Comparing 8x8 ", SFC, RED, "R" 
                        byte SFC, GREEN, "G", SFC, BLUE, "B", SFC, WHITE
                        byte " LED arrays. The 60mm array is from eBay. The "
                        byte " 38mm array is made by SimplyTronics. "
                        byte "This font 5x8 font comes with the SimplyTronics array. "
                        byte SF, FREE_DESIGN
                        byte " Free Design is a dot matrix font I found on the internet."
                        byte " I ", SD, 80, "think this font ", SD, 60
                        byte "is easier to read ", SD, 60, "when the text is "
                        byte "scrolling fast. "
                        'byte SFC, GREEN," (Sp", SD, 80, "eeding", SD, 60, " up ", SD, 40
                        'byte "scrolling) "
                        byte SFC, RED, "Besides ", SFC, ORANGE, SBC, BLUE, "the "
                        byte SFC, YELLOW, SBC, GREEN, "size "
                        byte SFC, GREEN, SBC, YELLOW, "difference, ", SFC, CYAN, SBC, RED
                        byte "the ", SFC, BLUE, SBC, ORANGE, "larger "
                        byte SFC, VIOLET, SBC, BLACK, "array is much brighter. ", SFC, WHITE
                        byte "The current brightness "
                        byte "level of the ", SFC, RED, "L", SFC, WHITE
                        byte "arge array is 64 of 255.  The ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall array is 255 or 255.   Turning the brightness of "
                        byte "both units down. ", SB, 56, SBST, 223, SFC, RED, "L", SFC, WHITE
                        byte "arge brightness is now 56. ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall brightness is now 223. "
                        byte SB, 48, SBST, 191, SFC, RED, "L", SFC, WHITE
                        byte "arge 48, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 191. "
                        byte SB, 40, SBST, 159, SFC, RED, "L", SFC, WHITE
                        byte "arge 40, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 159. " 
                        byte SB, 32, SBST, 127, SFC, RED, "L", SFC, WHITE
                        byte "arge 32, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 127. " 
                        byte SB, 24, SBST, 95, SFC, RED, "L", SFC, WHITE
                        byte "arge 24, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 95. " 
                        byte SB, 16, SBST, 63, SFC, RED, "L", SFC, WHITE
                        byte "arge 16, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 63. " 
                        byte SB, 8, SBST, 31, SFC, RED, "L", SFC, WHITE
                        byte "arge 8, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 31. "
                        byte SB, 24, SBST, 95, "Turning ", SB, 32, SBST, 127
                        byte "the ", SB, 40, SBST, 159, "brightness", SB, 48, SBST, 191
                        byte " back ", SB, 56, SBST, 223, "to where we ", SB, 64, SBST, 255, "started. "
                        byte SFC, RED, "L", SFC, WHITE
                        byte "arge 64, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 255. "
                        byte "The ", SB, 72, "lar", SB, 80, "ge ", SB, 88, "scr"
                        byte SB, 96, "een ", SB, 104, "can ", SB, 112, "get "
                        byte SB, 120, "even ", SB, 128, "bri", SB, 136, "ghter. ", SB, 144  
                        byte "And ", SB, 152, "bri", SB, 160, "ghter "
                        byte SB, 168, "sti", SB, 176, "ll. ", SB, 184 
                        byte "All ", SB, 192, "the ", SB, 200, "way ", SB, 208  
                        byte "up ", SB, 216, "to ", SB, 224, "its ", SB, 232
                        byte "bri", SB, 240, "ght", SB, 248, "est ", SB, 255
                        byte "level of 255."  
                        
                        
                             '1234567890123456789012345678901234567890123456789012345678901     
DAT messageBuffer1      byte 0[32]
                             '1234567890123456789012345678901234567890123456789012345678901     
DAT end                                                      